<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelRatePlanSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelRatePlanSupplement extends AbstractStructArrayBase
{
    /**
     * The Supplement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelRatePlanSupplement[]
     */
    public $Supplement;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelRatePlanSupplement
     * @uses ArrayOfJPSOAP_HotelRatePlanSupplement::setSupplement()
     * @param \StructType\JPSOAP_HotelRatePlanSupplement[] $supplement
     */
    public function __construct(array $supplement = array())
    {
        $this
            ->setSupplement($supplement);
    }
    /**
     * Get Supplement value
     * @return \StructType\JPSOAP_HotelRatePlanSupplement[]|null
     */
    public function getSupplement()
    {
        return $this->Supplement;
    }
    /**
     * Set Supplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanSupplement[] $supplement
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSupplement
     */
    public function setSupplement(array $supplement = array())
    {
        foreach ($supplement as $arrayOfJPSOAP_HotelRatePlanSupplementSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelRatePlanSupplementSupplementItem instanceof \StructType\JPSOAP_HotelRatePlanSupplement) {
                throw new \InvalidArgumentException(sprintf('The Supplement property can only contain items of \StructType\JPSOAP_HotelRatePlanSupplement, "%s" given', is_object($arrayOfJPSOAP_HotelRatePlanSupplementSupplementItem) ? get_class($arrayOfJPSOAP_HotelRatePlanSupplementSupplementItem) : gettype($arrayOfJPSOAP_HotelRatePlanSupplementSupplementItem)), __LINE__);
            }
        }
        $this->Supplement = $supplement;
        return $this;
    }
    /**
     * Add item to Supplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanSupplement $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSupplement
     */
    public function addToSupplement(\StructType\JPSOAP_HotelRatePlanSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelRatePlanSupplement) {
            throw new \InvalidArgumentException(sprintf('The Supplement property can only contain items of \StructType\JPSOAP_HotelRatePlanSupplement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Supplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelRatePlanSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelRatePlanSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelRatePlanSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelRatePlanSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelRatePlanSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Supplement
     */
    public function getAttributeName()
    {
        return 'Supplement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSupplement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
